

CREATE Form AS QFORMEX
    KeyPreview = True
    Width = 1950        '768 + 1152 + form.borders
    Height = 980
    Left = -8
    Font.Size = 11
    Caption = "Manual RNFL " + MyVersion
    OnClose = Form_Close
    OnKeyDown = Form_KeyDown
    OnKeyUp = Form_KeyUp
    OnMouseDown = Form_MouseDown
    OnMouseUp = Form_MouseUp
    OnMouseMove = Form_MouseMove
    OnPaint = FormRepaint

    CREATE ScanRadiusLabel AS QLABEL
        Left = 10
        Top = 780
        Width = 190
        Caption = "Circle scan radius"  + mu
    END CREATE
    CREATE ScanRadiusEdit AS QEDIT
        Left = 170
        Top = 780
        Width = 70
        Text = ""
    END CREATE

    CREATE StatusLabel AS QLABEL
        Left = 10
        Top = 860
        Width = 270
        Caption = ""
        Font.Size = 12
        Font.Bold = True
    END CREATE

    CREATE ResetFoveaButton AS QPANEL
        BevelWidth = 2
        BevelOuter = bvRaised 
        Left = 280
        Top = 780
        Width = 80
        Height = 28
        Caption = "Reset Fov"
        OnClick = ResetFovea
    END CREATE

    CREATE FoveaAngleLabel AS QLABEL
        Left = 280
        Top = 810
        Width = 100
        Caption = "Fov " + degr
    END CREATE


    CREATE NameLabel AS QLABEL
        Left = 420
        Top = 780
        Width = 239
        Caption = "Name:"
    END CREATE
    CREATE EyeLabel AS QLABEL
        Left = 420
        Top = 810
        Width = 100
        Caption = "Eye:"
    END CREATE
    CREATE QualityLabel AS QLABEL
        Left = 525
        Top = 810
        Width = 241
        Caption = "Quality:"
    END CREATE

    CREATE SLORevertButton AS QBUTTON
        Left = 680
        Top = 780
        Width = 76
        Caption = "Original"
        OnClick = ResetSLOimage
    END CREATE


    CREATE OCTPanel AS QPANEL
        Left = 790
        Top = 745
        Width = 1000
        Height = 100
        Color = RGB(228, 215, 186)
        CREATE SearchResLabel AS QLABEL
            Left = 6
            Top = 4
            Width = 60
            Height = 34
            Caption = "Match" + CHR$(13) + CHR$(10) + "area"
        END CREATE
        CREATE SearchResBox AS QCOMBOBOX
            Left = 70
            Top = 8
            Width = 60
            Height = 21
            Clear
            AddItems( "0.25", "0.5", "1.0", "1.5", "2.0", "3.0")
            ItemIndex = 2
        END CREATE

        CREATE OCTMatchesLabel AS QLABEL
            Left = 20
            Top = 45
            Width = 60
            Height = 28
            Caption = "Match visibility"
        END CREATE

        CREATE OCTMatchesVisibilityTrackbar AS QTRACKBAR
            Orientation = tbHorizontal
            Left = 6
            Top = 70
            Height = 26
            Width = 127
            Max = 127
            Frequency = 16
            Position = 127
            OnChange = OCTMatchesVisibility_OnChange
        END CREATE

        CREATE InvertOCTButton AS QBUTTON
            Left = 145
            Top = 8
            Width = 40
            Height = 34
            Caption = "W/B"
            OnClick = InvertOCT
        END CREATE
        CREATE OCTThicknessLabel AS QLABEL
            Font.Size = 12
            Font.Color = clGreen
            Font.Bold = True
            Left = 270
            Top = 10
            Width = 64
            Height = 34
            Color = OCTPanel.Color
            Caption = ""
            Visible = False
        END CREATE

        CREATE SplineButton AS QBUTTON
            Left = 195
            Top = 8
            Width = 64
            Height = 34
            Caption = "Lines"
            OnClick = SplineButton_Click
        END CREATE

        CREATE MedianFilterBox AS QCHECKBOX
            Left = 410
            Top = 2
            Width = 90
            Height = 28
            Hint = "Median filter OCT image"
            ShowHint = True
            Caption = "Median"
            Checked = False
            OnClick = MedianFilter_Click
        END CREATE

        CREATE MedianFilterSizeBox AS QCOMBOBOX
            Clear
            Left = 510
            Top = 4
            Width = 46
            Height = 38
            Hint = "Size of Median filter kernel"
            ShowHint = True
            AddItems("3", "5", "7", "9", "11", "13")
            ItemIndex = 1       '2nd item
        END CREATE

        CREATE AdaptiveThresholdCheckBox AS QCHECKBOX
            Left = 410
            Top = 26
            Width = 90
            Height = 28
            Hint = "Adaptive filter for OCT segmentation"
            ShowHint = True
            Caption = "Adapt Filter"
            Checked = False
            OnClick = DoSegmentation
        END CREATE


        CREATE PolyFitLayersCheckBox AS QCHECKBOX
            Left = 410
            Top = 52
            Width = 90
            Height = 28
            Hint = "Fit layers to polynomial curve"
            ShowHint = True
            Caption = "Poly. Fit"
            Checked = False
            OnClick = DoSegmentation
        END CREATE

        CREATE PolyFitLayersOrderBox AS QCOMBOBOX
            Clear
            Left = 510
            Top = 50
            Width = 46
            Height = 38
            Hint = "Order of  polynomial curve fit"
            ShowHint = True
            AddItems("2", "3", "4", "5", "6") 
            ItemIndex = 3                       '4th item
            OnChange = DoSegmentation
        END CREATE

        CREATE UseVesselMaskCheckBox AS QCHECKBOX
            Left = 410
            Top = 76
            Width = 90
            Height = 28
            Hint = "avoid segmentation in blood vessel shadows"
            ShowHint = True
            Caption = "Vess. Mask"
            Checked = False
            OnClick = DoSegmentation
        END CREATE

        CREATE ResetButton AS QBUTTON
            Left = 580
            Top = 8
            Width = 90
            Height = 34
            Hint = "Revert/Reset to original image"
            ShowHint = True
            Caption = "Original"
            OnClick = ResetOCTImage
        END CREATE

        CREATE ViewResultsButton AS QBUTTON
            Left = 720
            Top = 8
            Width = 100
            Height = 34
            Hint = "View results on normative template"
            ShowHint = True
            Caption = "View Results"
            OnClick = ToggleNormTemplate
        END CREATE

        CREATE SaveButn AS QBUTTON
            Left = 850 
            Top = 8 
            Width = 120
            Height = 32
            Caption = "Save >"
            Tag = False
            OnClick = SaveButtn_Click
        END CREATE
    END CREATE                          'OCTPanel



    CREATE SkipButn AS QBUTTON
        Left = 1640
        Top = 880
        Width = 120
        Height = 32
        Caption = "Skip"
        Tag = False
        OnClick = SkipButtn_Click
    END CREATE

    CREATE EndButn AS QBUTTON
        Left = 1790
        Top = 880
        Width = 120
        Height = 32
        Caption = "End"
        OnClick = EndButn_Click
    END CREATE

END CREATE          'main form




CREATE WaitForm AS QFORM
    Borderstyle = bstoolwindow
    Width = 440
    Height = 200
    Caption = "Please Wait, Processing..."
    Parent = Form
    CREATE WaitFormLabel AS QLABEL
        Font.Size = 12
        Font.Bold = True
        Left = 12
        Top = 24
        Height = 90
        Caption = ""    'WordWrap = true        'no effect
        Width = 260
    END CREATE
END CREATE




CREATE OpenFolderForm AS QFORM
    Font.Size = 11
    Width = 500
    Height = 730
    Caption = "Open Folder with Spectralis XML / Tiff files"
    OnResize = OpenFolderFormResize

    CREATE CurrentFolderNameLabel AS QLABEL
        Font.Bold = True
        Left = 4
        Top = 0
        Height = 28
    END CREATE
    CREATE SelectFolderButton AS QBUTTON
        Left = 267
        Top = 640
        Width = 170
        Height = 30
        Caption = "Select Folder"
        Default = True
        OnClick = OpenXMLFolder
    END CREATE
    CREATE CancelFolderButton AS QBUTTON
        Left = 26
        Top = 640
        Width = 90
        Height = 30
        Cancel = True
        Tag = False
        Caption = "Exit"
        OnClick = CancelOpenFolderForm
    END CREATE

    CREATE DirList AS QFILELISTBOX 
        ShowIcons = TRUE
        Mask = "*.*"
        AddFileTypes(ftDirectory)           'Add Directories
        DelFileTypes(ftNormal)              'Remove files
        OnClick = ChangeDirectories
        'OnDblClick = OpenXMLFolder
    END CREATE

    CREATE XMLlist AS QFILELISTBOX
        ShowIcons = TRUE
        Mask = "*.xml"
        'OnClick = OpenXMLFolder
        OnDblClick = OpenXMLFolder
    END CREATE
END CREATE





DIM LayerShowBox(MaxLayers) AS QCHECKBOX
DIM LayerDelete(MaxLayers) AS QBUTTON
DEFINT zzz
FOR zzz = 0 TO MaxLayers
    LayerShowBox(zzz).Parent = OCTPanel
    LayerShowBox(zzz).Tag = zzz
    LayerShowBox(zzz).Left = 270
    LayerShowBox(zzz).Top = 2 + (zzz * 24)
    LayerShowBox(zzz).Width = 64
    LayerShowBox(zzz).Height = 20
    LayerShowBox(zzz).Font.Size = 10
    LayerShowBox(zzz).Checked = True
    LayerShowBox(zzz).OnClick = LayerShowBox_Clicked
    IF zzz = cILM THEN LayerShowBox(zzz).Caption = "ILM"
    IF zzz = cNFL THEN LayerShowBox(zzz).Caption = "NFL"
    IF zzz = cONL THEN LayerShowBox(zzz).Caption = "ONL"
    IF zzz = cBM  THEN LayerShowBox(zzz).Caption = "BM"

    LayerDelete(zzz).Parent = OCTPanel
    LayerDelete(zzz).Tag = zzz
    LayerDelete(zzz).Left = 345
    LayerDelete(zzz).Top = 4 + (zzz * 24)
    LayerDelete(zzz).Width = 18
    LayerDelete(zzz).Height = 18
    LayerDelete(zzz).Font.Bold = True
    LayerDelete(zzz).ShowHint = True
    LayerDelete(zzz).Hint = "Delete this segmentation then manually draw a new one"
    LayerDelete(zzz).Caption = "X"
    LayerDelete(zzz).OnClick = LayerDelete_Click
NEXT zzz
