$TYPECHECK ON
'api interface for the OpenCV_Wrapper DLL
'July, 2018


TYPE cv_WrapperImageMatch_t 
    width                   AS INTEGER
    height                  AS INTEGER
    bpp                     AS INTEGER
    lpPixelData             AS LONG
    template_width          AS INTEGER
    template_height         AS INTEGER
    template_bpp            AS LONG
    template_lpPixelData    AS INTEGER
    detectorType            AS INTEGER
    detectorParameter       AS SINGLE
    detectorParameter2      AS SINGLE
    minNumberMatches        AS INTEGER      'default is 7 if not set
    MatchMethod             AS INTEGER      'full Homography, rigid body affine, simple detector translation, or cross correlation method
	RANSAC                  AS INTEGER      '0 = off, else range of 1 to 10 can go up to 50
    RejectPercentage        AS SINGLE
    RejectTresholdDist      AS SINGLE
    RejectRatioTestValue    AS SINGLE
	RejectAngleSD           AS SINGLE
    RejectPixelShiftSD      AS SINGLE
	RejectPixelDist         AS INTEGER
    offsetX                 AS INTEGER      'global translation from homography/ affine matrix
    offsetY                 AS INTEGER      'global translation from homography/ affine matrix
	rotationDeg             AS SINGLE       'averaged rotation
	scaleX                  AS SINGLE
    scaleY                  AS SINGLE
    shear                   AS SINGLE
    centerX                 AS INTEGER      'center of matching rectangle
    centerY                 AS INTEGER      'center of matching rectangle
    Match_Corner1_x         AS INTEGER      'RQ can't do arrays of Point2i  ...
    Match_Corner1_y         AS INTEGER      'RQ can't do arrays of Point2i  ...
    Match_Corner2_x         AS INTEGER
    Match_Corner2_y         AS INTEGER
    Match_Corner3_x         AS INTEGER
    Match_Corner3_y         AS INTEGER
    Match_Corner4_x         AS INTEGER
    Match_Corner4_y         AS INTEGER
    NumMatchPoints          AS INTEGER      'final result of number matched points
    PlotResults             AS INTEGER
END TYPE


DECLARE FUNCTION cv_adaptiveThreshold LIB "OpenCV_Wrapper.dll" ALIAS "_cv_adaptiveThreshold@20"(maxValue as integer, adaptiveMethod as integer, thresholdType as integer, blockSize as integer, C as integer) AS INTEGER
DECLARE FUNCTION cv_BilateralFilter LIB "OpenCV_Wrapper.dll" ALIAS "_cv_BilateralFilter@12" (d as integer, byRef sigmaColor as double, byRef sigmaSpace as double) AS INTEGER
DECLARE FUNCTION cv_Bitmap2Mat LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Bitmap2Mat@16" (wid as integer, hei as integer, BPP as integer, lpPixelData as long) AS INTEGER
DECLARE FUNCTION cv_Blur LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Blur@8"(SizX as integer, SizY as integer) AS INTEGER
DECLARE FUNCTION cv_calcOpticalFlowFarneback LIB "OpenCV_Wrapper.dll" ALIAS "_cv_calcOpticalFlowFarneback@16"(lpPixelDataPrevFrame as long, OutArryXPTR as long, OutArryYPTR as long, byref ArrySize as integer) AS INTEGER
DECLARE FUNCTION cv_CannyThreshold LIB "OpenCV_Wrapper.dll" ALIAS "_cv_CannyThreshold@12"(threshold1 as integer, threshold2 as integer, apertureSize as integer) AS INTEGER
DECLARE FUNCTION cv_CLAHE LIB "OpenCV_Wrapper.dll" ALIAS "_cv_CLAHE@4"(ClipLimit as integer) AS INTEGER
DECLARE FUNCTION cv_Clear LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Clear@0"() AS INTEGER
DECLARE FUNCTION cv_Close LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Close@0"() AS INTEGER
DECLARE FUNCTION cv_ContrastWindow LIB "OpenCV_Wrapper.dll" ALIAS "_cv_ContrastWindow@8"(byRef alpha as double, beta as integer) AS INTEGER
DECLARE FUNCTION cv_ConvertGreyScale LIB "OpenCV_Wrapper.dll" ALIAS "_cv_ConvertGreyScale@0"() AS INTEGER
DECLARE FUNCTION cv_ConvertRGB LIB "OpenCV_Wrapper.dll" ALIAS "_cv_ConvertRGB@0"() AS INTEGER
DECLARE FUNCTION cv_CrossCorrelateMatch LIB "OpenCV_Wrapper.dll" ALIAS "_cv_CrossCorrelateMatch@4"(Byref lpWrapperImageMatch as cv_WrapperImageMatch_t) AS INTEGER
DECLARE FUNCTION cv_CustomFilter LIB "OpenCV_Wrapper.dll" ALIAS "_cv_CustomFilter@8"(KernelArryPtr as long, kernelSize as integer) AS INTEGER
DECLARE FUNCTION cv_Destroy LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Destroy@0"() AS INTEGER
DECLARE FUNCTION cv_DetectPupil LIB "OpenCV_Wrapper.dll" ALIAS "_cv_DetectPupil@44"(pPixelBuf as long, hei AS LONG, wid AS LONG, ByRef PupilCenterX AS INTEGER, ByRef PupilCenterY AS INTEGER, ByRef PupilRadius AS INTEGER, ByRef GlintCenterX AS INTEGER, ByRef GlintCenterY AS INTEGER, ByRef GlintRadius AS INTEGER, NormContast AS INTEGER, MaxGlintOffset AS INTEGER) AS INTEGER
DECLARE FUNCTION cv_Dilate LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Dilate@8"(inShape as integer, inSize as integer) AS INTEGER
DECLARE FUNCTION cv_EqualizeHistogram LIB "OpenCV_Wrapper.dll" ALIAS "_cv_EqualizeHistogram@0"() AS INTEGER
DECLARE FUNCTION cv_Erode LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Erode@8"(inShape as integer, inSize as integer) AS INTEGER
DECLARE FUNCTION cv_FindVesselShadows LIB "OpenCV_Wrapper.dll" ALIAS "_cv_FindVesselShadows@32"(wid as integer, hei as integer, BPP as integer,lpPixelData AS long, lpVesselData AS long, topOffset  as integer, winSiz as integer, byref thresh as double) AS INTEGER
DECLARE FUNCTION cv_GaussianBlur LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GaussianBlur@16"(SizX as integer, SizY as integer, sdX as integer, sdY as integer) AS INTEGER
DECLARE FUNCTION cv_GetBytesPerPixel LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetBytesPerPixel@0"() AS INTEGER
DECLARE FUNCTION cv_GetFrameCount LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetFrameCount@0"() AS INTEGER
DECLARE FUNCTION cv_GetFramePosition LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetFramePosition@0"() AS INTEGER
DECLARE FUNCTION cv_GetFrameRate LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetFrameRate@0"() AS INTEGER
DECLARE FUNCTION cv_GetHeight LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetHeight@0"() AS INTEGER
DECLARE FUNCTION cv_GetPGREmbeddedTime LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetPGREmbeddedTime@4"(lpPixelData as long) AS DOUBLE
DECLARE FUNCTION cv_GetPixelFormat LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetPixelFormat@0"() AS INTEGER
DECLARE FUNCTION cv_GetWidth LIB "OpenCV_Wrapper.dll" ALIAS "_cv_GetWidth@0"() AS INTEGER
DECLARE FUNCTION cv_Grab LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Grab@0"() AS INTEGER
DECLARE FUNCTION cv_HoughDetectPupil LIB "OpenCV_Wrapper.dll" ALIAS "_cv_HoughDetectPupil@40"(pPixelBuf as long, hei AS LONG, wid AS LONG, ByRef PupilCenterX AS INTEGER, ByRef PupilCenterY AS INTEGER, ByRef PupilRadius AS INTEGER, ByRef GlintCenterX AS INTEGER, ByRef GlintCenterY AS INTEGER, ByRef GlintRadius AS INTEGER, NormContast AS INTEGER) AS INTEGER
DECLARE FUNCTION cv_imRead LIB "OpenCV_Wrapper.dll" ALIAS "_cv_imRead@8"(ByRef myFileName as string, imgConversion as integer) AS INTEGER
DECLARE FUNCTION cv_imWrite LIB "OpenCV_Wrapper.dll" ALIAS "_cv_imWrite@12"(ByRef myFileName as string, imgType as integer, quality as integer) AS INTEGER
DECLARE FUNCTION cv_kMeans LIB "OpenCV_Wrapper.dll" ALIAS "_cv_kMeans@8"(numLevels as integer, num_Max_Iterations as integer) AS INTEGER
DECLARE FUNCTION cv_Laplacian LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Laplacian@16"(ksize as integer, byRef scale as double, byRef delta as double, borderType as integer) AS INTEGER
DECLARE FUNCTION cv_Mat2Bitmap LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Mat2Bitmap@16" (wid as integer, hei as integer, BPP as integer, lpPixelData as long) AS INTEGER
DECLARE FUNCTION cv_MatchImages LIB "OpenCV_Wrapper.dll" ALIAS "_cv_MatchImages@4"(Byref lpWrapperImageMatch as cv_WrapperImageMatch_t) AS INTEGER
DECLARE FUNCTION cv_MedianBlur LIB "OpenCV_Wrapper.dll" ALIAS "_cv_MedianBlur@4"(Siz as integer) AS INTEGER
DECLARE FUNCTION cv_NormalizeContrast LIB "OpenCV_Wrapper.dll" ALIAS "_cv_NormalizeContrast@4"(Methd as integer) AS INTEGER
DECLARE FUNCTION cv_NormalizeContrast2 LIB "OpenCV_Wrapper.dll" ALIAS "_cv_NormalizeContrast2@20"(lpMyImage as long, wid as integer, hei as integer, inBPP as integer, Methd as integer) AS INTEGER
DECLARE FUNCTION cv_Open LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Open@4"(Byref myFileName as string) AS INTEGER
DECLARE FUNCTION cv_OpenCam LIB "OpenCV_Wrapper.dll" ALIAS "_cv_OpenCam@4"(devNum as integer) AS INTEGER
DECLARE FUNCTION cv_OtsuThreshold LIB "OpenCV_Wrapper.dll" ALIAS "_cv_OtsuThreshold@4"(thresholdType as integer) AS INTEGER
DECLARE FUNCTION cv_Pow LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Pow@4"(byRef ThePower as double) AS INTEGER
DECLARE FUNCTION cv_Read LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Read@4"(lpPixelData as long) AS INTEGER
DECLARE FUNCTION cv_Resize LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Resize@12"(wid as integer, hei as integer, interpFlag as integer) AS INTEGER
DECLARE FUNCTION cv_SetBitsPerPixel LIB "OpenCV_Wrapper.dll" ALIAS "_cv_SetBitsPerPixel@4"(inBPP as integer) AS INTEGER
DECLARE FUNCTION cv_SetFramePosition LIB "OpenCV_Wrapper.dll" ALIAS "_cv_SetFramePosition@4"(newPos as integer) AS INTEGER
DECLARE FUNCTION cv_SetFramePositionByTime LIB "OpenCV_Wrapper.dll" ALIAS "_cv_SetFramePositionByTime@4"(newPos as integer) AS INTEGER
DECLARE FUNCTION cv_SetFrameTime LIB "OpenCV_Wrapper.dll" ALIAS "_cv_SetFrameTime@4"(ByRef inTimeMS as double) AS INTEGER
DECLARE FUNCTION cv_SetPupilDetectionParams LIB "OpenCV_Wrapper.dll" ALIAS "_cv_SetPupilDetectionParams@16"(inPupilThresh as integer, inGlintThresh as integer, inPupilSize as integer, inGlintSize as integer) AS INTEGER
DECLARE FUNCTION cv_Sobel LIB "OpenCV_Wrapper.dll" ALIAS "_cv_Sobel@16"(ksize as integer, byRef scale as double, byRef delta as double, borderType as integer) AS INTEGER
DECLARE FUNCTION cv_cvtColor LIB "OpenCV_Wrapper.dll" ALIAS "_cv_cvtColor@4"(frmt as integer) AS INTEGER
DECLARE FUNCTION cv_isOpened LIB "OpenCV_Wrapper.dll" ALIAS "_cv_isOpened@0"() AS INTEGER
DECLARE FUNCTION cv_threshold LIB "OpenCV_Wrapper.dll" ALIAS "_cv_threshold@12"(thresh as integer, maxval as integer, Threshtype as integer) AS INTEGER




'image read formats
CONST CV_LOAD_IMAGE_UNCHANGED  =-1      '8bit, color or not
CONST CV_LOAD_IMAGE_GRAYSCALE  =0       '8bit, gray
CONST CV_LOAD_IMAGE_COLOR      =1 
CONST CV_LOAD_IMAGE_ANYDEPTH   =2
CONST CV_LOAD_IMAGE_ANYCOLOR   =4

'image write formats
CONST CV_IMWRITE_JPEG_QUALITY = 1
CONST CV_IMWRITE_PNG_COMPRESSION = 16
CONST CV_IMWRITE_PXM_BINARY = 32

'use for cv_cvtColor
CONST CV_BGR2BGRA    =0
CONST CV_RGB2RGBA    =0
CONST CV_BGRA2BGR    =1
CONST CV_RGBA2RGB    =1
CONST CV_BGR2RGBA    =2
CONST CV_RGB2BGRA    =2
CONST CV_RGBA2BGR    =3
CONST CV_BGRA2RGB    =3
CONST CV_BGR2RGB     =4
CONST CV_RGB2BGR     =4
CONST CV_BGRA2RGBA   =5
CONST CV_RGBA2BGRA   =5
CONST CV_BGR2GRAY    =6
CONST CV_RGB2GRAY    =7
CONST CV_GRAY2BGR    =8
CONST CV_GRAY2RGB    =8
CONST CV_GRAY2BGRA   =9
CONST CV_GRAY2RGBA   =9
CONST CV_BGRA2GRAY   =10
CONST CV_RGBA2GRAY   =11

'pixel depth constants
CONST CV_8UC1 = 0
CONST CV_8UC2 = 8
CONST CV_8UC3 = 16
CONST CV_8UC4 = 24

'filter constants
CONST IPL_BORDER_REFLECT_101  = 4  'default
CONST IPL_BORDER_TRANSPARENT  = 5

'thresholding flags
CONST CV_THRESH_BINARY=0
CONST CV_THRESH_BINARY_INV=1
CONST CV_THRESH_TRUNC=2
CONST CV_THRESH_TOZERO=3
CONST CV_THRESH_TOZERO_INV=4
CONST CV_THRESH_MASK=7
CONST CV_THRESH_OTSU=8 
CONST CV_ADAPTIVE_THRESH_MEAN_C=0
CONST CV_ADAPTIVE_THRESH_GAUSSIAN_C=1

'resize / anti alias flags
CONST CV_INTER_NEAREST=0            'nearest neighbor interpolation
CONST CV_INTER_LINEAR=1             'bilinear interpolation
CONST CV_INTER_CUBIC=2              'bicubic interpolation 
CONST CV_INTER_AREA=3               'area-based (or super) significantly faster than cv_INTER_CUBIC
CONST CV_INTER_LANCZOS4=4           'Lanczos interpolation over 8x8 neighborhood
CONST CV_INTER_MAX=7 
CONST CV_WARP_INVERSE_MAP=16

'normalization methods
CONST CV_NORM_INF=1
CONST CV_NORM_L1=2
CONST CV_NORM_L2=4
CONST CV_NORM_TYPE_MASK=7
CONST CV_NORM_RELATIVE=8
CONST CV_NORM_MINMAX=32

'detector matcher types for DLL
CONST CV_GRID_ADAPTED_FAST = 0
CONST CV_FAST_DETECTOR = 1
CONST CV_SURF_DETECTOR = 2
CONST CV_SIFT_DETECTOR = 3
CONST CV_PYRAMID_ADAPTED_FEATUREDETECTOR = 4
CONST CV_ORB_FEATUREDETECTOR = 5

'morph variables for erode or dilate
CONST CV_MORPH_RECT=0           'square shape
CONST CV_MORPH_CROSS=1
CONST CV_MORPH_ELLIPSE=2
CONST CV_MORPH_HORIZLINE=3      'custom to OpenCV Wrapper
CONST CV_MORPH_VERTLINE=4       'custom to OpenCV Wrapper

'cross correlation matching methods for MatchingMethod entry
CONST CV_TM_SQDIFF = 0 
CONST CV_TM_SQDIFF_NORMED = 1 
CONST CV_TM_CCORR = 2 
CONST CV_TM_CCORR_NORMED = 3 
CONST CV_TM_CCOEFF = 4 
CONST CV_TM_CCOEFF_NORMED = 5
CONST CV_FULL_HOMOGRAPHY = 16       'full perspective scale, rotation, translation, shear
CONST CV_RIGID_AFFINE = 32          'rigid body with rotation & translation
CONST CV_SIMPLE_TRANSLATION = 64    'rigid body, no rotation; shift only, like cross correlation but with feature detectionn


